var bizagiUtil = require('bz-util');
var REQUIRED = bizagiUtil.REQUIRED;
var ERROR = bizagiUtil.error;
var RESPONSE = bizagiUtil.getResponse;
var xlsx = REQUIRED('xlsx');
 
/**
 * @author Bizagi
 */ 
 
 function convertCell(cell){
	
	var result ;
	
	if (cell != undefined)
		result = {
		value:cell.v,
		formattedText:cell.w,
		type:cell.t,
		formula:cell.f
	};
	
	return result;
}

function invoke(globals, actionName, data, authenticationType, LOG, callback) {
LOG.debug(['[bz-excel.', actionName, '] globals: ', globals, ' --- data: ', data]);
    
	var error = bizagiUtil.validator.requiredParameters({'cellname':data.inputs.input.cellname,'workbookdata':data.inputs.input.workbookdata,'worksheetname':data.inputs.input.worksheetname, 'callback':callback});
    if (error){
        LOG.error(['[net-excel-connector.', actionName, '] Error: ', error]);
        callback(error);
        return;
    } 	
    
    LOG.info(['[bz-excel.', actionName, '] invoke... getCellData: { cellname: ', data.inputs.input.cellname, ', worksheetname:', data.inputs.input.worksheetname, ', workbookdata:... }']);
    
    var reply;
    try{        
        var bufferedData= new Buffer(data.inputs.input.workbookdata, 'base64');
        var workbook = xlsx.read(bufferedData.toString("binary"), {type:"binary"});
        var worksheet = workbook.Sheets[data.inputs.input.worksheetname];
        var cell = worksheet[data.inputs.input.cellname];
    	reply = { cell: convertCell(cell) };
    }
    catch (e){
        var error = { statusCode:500, message: e.toString()};
    }
    
    if(error){
        error = RESPONSE(null, error, error.statusCode, ERROR('EXCEL.ERROR',[error.statusCode, error.message]));
        LOG.error(['[bz-excel.', actionName, '] Error: ', error]);
		callback(error);
	}	
	else{
        reply =RESPONSE(reply, null, 200);
        LOG.debug(['[bz-excel.', actionName, '] Response Success with response... ', reply]);
		callback(reply);
	}	 
}

exports.invoke = invoke;